# -*- coding:Utf-8 -*-
# hud_hp V1.202p (02/02/2009) by DoCky


import es, os, psyco, langlib, playerlib, gamethread
psyco.full()

hh_info = es.AddonInfo()
hh_info.version = "1.202p"
hh_info.author = "DoCky"
hh_info.name = "hud_hp"

vers = es.ServerVar(hh_info.name, hh_info.version, "by DoCky -")
vers.set(hh_info.version)
vers.makepublic()

team = es.ServerVar("hh_team")
time = es.ServerVar("hh_time")
tags = ""

class Langage:
    def __init__(self):
        self.lang = langlib.Strings("%s/language.ini" % es.getAddonPath("hud_hp"))

    def exists(self, string):
        if self.lang.has_key(string): return True
        else: return False

    def getLang(self, userid):
        try: lang = langlib.getLangAbbreviation(es.createplayerlist(userid)[userid]["language"])
        except KeyError: lang = langlib.getDefaultLang()
        finally: return lang

    def getText(self, string, userid, keyword = {}):
        if len(keyword): return self.lang(string, opts = keyword, lang = self.getLang(userid))
        else: return self.lang(string, lang = self.getLang(userid))

def es_map_start(event_var):
    init()

def load():
    init()

def init():
    global langage, tags, numb
    langage = Langage()
    es.server.cmd("es_xmexec ../addons/eventscripts/hud_hp/config.cfg")
    if not int(team): tags, numb = "#human,#alive", "23"
    elif int(team) == 1: tags, numb = "#human,#alive,#t", "2"
    elif int(team) == 2: tags, numb = "#human,#alive,#ct", "3"
    loop(tags)

def loop(tags):
    hint(playerlib.getUseridList(tags))

def hint(playerlist):
    for userid in playerlist:
        es.usermsg("create", "hh_hint", "HintText")
        es.usermsg("write", "byte", "hh_hint", "1")
        es.usermsg("write", "string", "hh_hint", langage.getText("hud hp", userid, {"healthpoint" : es.getplayerprop(userid, "CBasePlayer.m_iHealth")}))
        es.usermsg("send", "hh_hint", userid, "0")
        es.usermsg("delete", "hh_hint")
    gamethread.delayedname(5, "hud_hp", loop, tags)

def unload():
    try: gamethread.cancelDelayed("hud_hp")
    except: pass

def round_end(event_var):
    try: gamethread.cancelDelayed("hud_hp")
    except: pass

def round_start(event_var):
    if int(time) <= 0: loop(tags)
    else: gamethread.delayed(int(time), loop, tags)

def player_hurt(ev):
    if ev["es_userteam"] in numb:
        if not es.getplayerprop(ev["userid"], "CBasePlayer.pl.deadflag"): hint((ev["userid"],))
        else:
            es.usermsg("create", "hh_hint", "ResetHUD")
            es.usermsg("write", "byte", "hh_hint", -1)
            es.usermsg("send", "hh_hint", ev["userid"], 1)
            es.usermsg("delete", "hh_hint")

